//--------------------------------------------------------------------//
// f܂ł̋

var canvas;			// LoXvf
var context;	 		// ReLXg
var pressed;			// }EX{^
var mx,my;			// }EXʒu
var cx,cy;			// ʒSʒu
var sa;				// _px
var planets=[];			// fXg
var rcoef;			// 1AU ̃sNZ
var thres;			// fEOf臒l
var maxRadius;			// z̋̍ől
var epoch=2451545.0;		// EX
var julianDay;			// EX
var viewMode;			// \[h
var scale;			// ڐ
var setBaseSw;			// f|C^ؑ
var p1,p2;			// f|C^

// f^Cv
var SUN=0;			// z
var INNER_PLANET=1;		// f
var OUTER_PLANET=2;		// Of

var EPOCH_JD=2440587.5;		// 1970 N 1  1  00:00:00 GMT ̃EX
var MJD_EPOCH=2400000.5;	// EX̊_
var MILLIS_TO_DAY=1.0/8.64E7;	// Ԃ~b֕ϊW

var FONT_SIZE=14;		// tHgTCY
var SCALE_SIZE=3;		// ڐTCY
var TO_RADIAN=Math.PI/180.0;	// pxWAɕϊW
var LINE_COLOR='rgb(255,255,255)';	// ftHg\F

var THETA_X=15.0;		// _oxω
var THETA_Y=10.0;		// _ܓxω

// f
// fileName - f[^t@C
function initPlanet(fileName){
  initCanvas();
  readPlanetDataFile(fileName);
  viewMode=INNER_PLANET;
  setInOut();
  loop();
}

// LoX
function initCanvas(){
  canvas=document.getElementById('planet');
  canvas.width=canvas.clientWidth;
  canvas.height=canvas.clientHeight;
  canvas.addEventListener('mousedown',mousePressed,false);
  canvas.addEventListener('mouseup',mouseReleased,false);
  canvas.addEventListener('mousemove',mouseMoved,false);
  document.addEventListener('keydown',keyPressed,false);
  context=canvas.getContext('2d');
  context.strokeStyle=LINE_COLOR;
  context.font=FONT_SIZE+"px 'Arial'";
  pressed=false;
  mx=0;
  my=0;
  cx=canvas.width/2;
  cy=canvas.height/2;
  sa=new SphericalAngle();
  sa.set(-0.5*Math.PI,Math.PI/6.0);
  scale=new Scale();
  setBaseSw=false;
  p1=null;
  p2=null;
}

// }EX{^̏s
function mousePressed(e){
  pressed=true;
  mx=e.clientX;
  my=e.clientY;
  var rect=e.target.getBoundingClientRect();
  var pl=getPlanet(mx-rect.left,my-rect.top);
  if(pl!==null){
    if(setBaseSw){
      p1=pl;
      setBaseSw=false;
    }
    else{
      p2=pl;
    }
    draw();
  }
}

// }EX{^𗣂̏s
function mouseReleased(e){
  pressed=false;
}

// }EX{^ړ̏s
function mouseMoved(e){
  if(pressed){
    rotate(mx-e.clientX,e.clientY-my);
    mx=e.clientX;
    my=e.clientY;
    draw();
  }
}

// L[̏s
function keyPressed(e){
  switch(e.keyCode){
    case 37:		// (Numpad4 Off)
    case 65:		// A
    case 100:		// Numpad4 On
      rotate(THETA_X,0);
      draw();
      break;
    case 39:		// E(Numpad6 Off)
    case 70:		// F
    case 102:		// Numpad6 On
      rotate(-THETA_X,0);
      draw();
      break;
    case 40:		// (Numpad2 Off)
    case 68:		// D
    case 98:		// Numpad2 On
      rotate(0,THETA_Y);
      draw();
      break;
    case 38:		// (Numpad8 Off)
    case 83:		// S
    case 104:		// Numpad8 On
      rotate(0,-THETA_Y);
      draw();
      break;
    case 12:		// (Numpad5 Off)
    case 53:		// 5
    case 67:		// C
    case 101:		// Numpad5 On
      if(viewMode==OUTER_PLANET){
      	viewMode=INNER_PLANET;
      }
      else{
      	viewMode=OUTER_PLANET;
      }
      draw();
      break;
    case 107:		// Numpad+
    case 187:		// +
      movePointer(0,1);
      break;
    case 109:		// Numpad-
    case 189:		// -
      movePointer(0,-1);
      break;
    case 35:		// End(Numpad1 Off)
    case 49:		// 1
    case 97:		// Numpad1 On
      movePointer(1,1);
      break;
    case 45:		// Ins(Numpad0 Off)
    case 48:		// 0
    case 96:		// Numpad0 On
      movePointer(1,-1);
      break;
  }
}

// ff[^t@Cǂݍ
// fileName - f[^t@C
function readPlanetDataFile(fileName){
  var xhr=new XMLHttpRequest();
  try{
    xhr.open('GET',fileName,false);
  }
  catch(e){
    alert(e);
  }
  xhr.onreadystatechange=function(){
    if((xhr.readyState===4) && ((xhr.status===0) || (xhr.status===200))){
      readPlanetData(xhr.responseText.split(/\r?\n/g));
    }
  };
  xhr.send(null);
}

// ff[^t@Cǂݍ
// s - f[^̃Xg
function readPlanetData(s){
  planets.length=0;
  var ss=s[0].trim().replace(/\t/g," ").split(/\s+/);
  thres=Number(ss[1]);
  epoch=Number(ss[3]);
  maxRadius=0.0;

  for(var i=2;i<s.length;i++){
    ss=s[i].trim().replace(/\t/g," ").split(/\s+/);
    if(ss.length>9){
      var pinv=Number(ss[9]);
      if(pinv!==0.0){
      	pinv=2.0*Math.PI/(365.25*pinv);
      }
      var pl=new Planet(ss[0],ss[1],
      	      	      	Number(ss[2])+1,Number(ss[3]),Number(ss[4]),
      	      	      	TO_RADIAN*Number(ss[5]),
      	      	      	TO_RADIAN*Number(ss[6]),
      	      	      	TO_RADIAN*Number(ss[7]),
      	      	      	TO_RADIAN*Number(ss[8]),pinv);
      pl.setType(thres);
      planets.push(pl);
      maxRadius=Math.max(maxRadius,pl.getMaxRadius());
    }
  }
  if(planets.length>0){
    p1=planets[0];
    p2=planets[0];
  }
}

// _ʒu]
// dx,dy - x,yWړ
function rotate(dx,dy){
  sa.rotate(TO_RADIAN*dx,TO_RADIAN*dy);
}

// NbNfԂ
// x,y - }EXʒu
function getPlanet(x,y){
  for(var i=0;i<planets.length;i++){
    if(planets[i].click(x,y)) return planets[i];
  }
  return null;
}

// f|C^ړ
// index - |C^CfbNX
// dir - XgVtgl
function movePointer(index,dir){
  switch(index){
    case 0:
      p1=neighbour(p1,dir);
      break;
    default:
      p2=neighbour(p2,dir);
      break;
  }
  draw();
}

// Xg̗אڂfԂ
// pl - _ƂȂf
// dir - XgVtgl
function neighbour(pl,dir){
  planets.sort(function(p1,p2){
    var r1=p1.getMaxRadius();
    var r2=p2.getMaxRadius();
    if(r1<r2)      return -1;
    else if(r1>r2) return 1;
    else           return 0;
  });
  var index=planets.indexOf(pl)+dir;
  if(index<0) index+=planets.length;
  return planets[index%planets.length];
}

// [v֐
var step=0;
function loop(){
  step++;
  if(step%10===0) draw();
  requestAnimationFrame(loop);
}

var MIN_RADIUS=1.0E-8;	// f̋Oa̍ŏl
// `悷
function draw(){
  context.fillStyle='rgb(0,0,0)';
  context.fillRect(0,0,canvas.width,canvas.height);
  drawPointer();
  context.fillStyle=LINE_COLOR;
  drawCalendar();
  var viewRadius=MIN_RADIUS;
  if(viewMode==INNER_PLANET){
    viewRadius=Math.max(thres,viewRadius);
  }
  else{
    viewRadius=Math.max(maxRadius,viewRadius);
  }
  rcoef=0.9*Math.min(cx,cy)/viewRadius;
  scale.set(viewRadius);
  scale.draw();
  for(var i=0;i<planets.length;i++){
    planets[i].calculateCoordinates();
    planets[i].setViewPosition();
  }
  planets.sort(function(p1,p2){
    if(p1.vp.z<p2.vp.z)      return -1;
    else if(p1.vp.z>p2.vp.z) return 1;
    else                     return 0;
  });
  for(i=0;i<planets.length;i++){
    planets[i].draw();
  }
}

var AU_TO_KM=1.4959787E8;	//  AU  km ֕ϊW
// f|C^`悷
function drawPointer(){
  var d=p1.distance(p2);
  var texts=['from '+p1.name,'to '+p2.name,
      	     '  '+d.toFixed(4)+'AU',' ='+parseInt(AU_TO_KM*d)+'km'];
  var x=0;
  for(var i=0;i<4;i++){
    var metrix=context.measureText(texts[i]);
    x=Math.max(x,metrix.width);
  }
  x=canvas.width-x;
  context.fillStyle=p1.color;
  context.fillText(texts[0],x,FONT_SIZE);
  context.fillStyle=p2.color;
  context.fillText(texts[1],x,2*FONT_SIZE);
  context.fillStyle=LINE_COLOR;
  context.fillText(texts[2],x,3*FONT_SIZE);
  context.fillText(texts[3],x,4*FONT_SIZE);
}

// J_[`悷
function drawCalendar(){
  var date=new Date();
  julianDay=EPOCH_JD+MILLIS_TO_DAY*date.getTime();
  var mjd=julianDay-MJD_EPOCH;
  var texts=['JST:'+dateString(date.getFullYear(),date.getMonth(),
      	      	      	       date.getDate(),date.getHours(),
      	      	      	       date.getMinutes(),date.getSeconds()),
      	     'GMT:'+dateString(date.getUTCFullYear(),date.getUTCMonth(),
      	      	      	       date.getUTCDate(),date.getUTCHours(),
      	      	      	       date.getUTCMinutes(),date.getUTCSeconds()),
      	     'JD:'+julianDay.toFixed(4),
      	     'MJD:'+mjd.toFixed(4)];
  var x=0;
  for(var i=0;i<4;i++){
    var metrix=context.measureText(texts[i]);
    x=Math.max(x,metrix.width);
  }
  x=canvas.width-x;
  cx=x/2;
  for(i=0;i<4;i++){
    context.fillText(texts[i],x,canvas.height-(3-i)*FONT_SIZE-2);
  }
}

// Ԃ
// yy,mm,dd,h,m,s - NE(-1)EEEEb
function dateString(yy,mm,dd,h,m,s){
  return yy+'/'+('0'+(mm+1)).slice(-2)+'/'+('0'+dd).slice(-2)+' '
      	+('0'+h).slice(-2)+':'+('0'+m).slice(-2)+':'+('0'+s).slice(-2);
}

// ݒ
function setBase(){
  setBaseSw=true;
}

// fEOfؑ
function setInOut(){
  var elems=document.getElementsByName('inout');
  if(elems[0].checked){
    viewMode=INNER_PLANET;
  }
  else{
    viewMode=OUTER_PLANET;
  }
  draw();
}

//--------------------------------------------------------------------//
// ff[^
// name - f̖O
// color - \F
// radius - \a
// sma - Oa AU
// eccen - S
// lofp - ߓ_o(rad)
// lofan - _o(rad)
// inc - OXΊp(rad)
// meanl - ωo(rad)
// pinv - px(rad/)
var Planet=function(name,color,radius,sma,eccen,lofp,lofan,inc,meanl,pinv){
  this.name=name;
  this.color='#'+color;
  this.radius=radius;
  this.sma=sma;
  this.eccen=eccen;
  this.lofp=lofp;
  this.lofan=lofan;
  this.inc=inc;
  this.meanl=meanl;
  this.pinv=pinv;
  this.pltype=SUN;
  this.p=new Point3D(0,0,0);
  this.vp=new Point3D(0,0,0);
};

// f^Cv𔻕ʂ
// thres - fEOf臒l
Planet.prototype.setType=function(thres){
  if(this.sma===0){		// z
    this.pltype=SUN;
  }
  else if(this.sma<=thres){	// f
    this.pltype=INNER_PLANET;
  }
  else{				// Of
    this.pltype=OUTER_PLANET;
  }
};

// _Ԃ _ = Oa~( 1 + S)
Planet.prototype.getMaxRadius=function(){
  return this.sma*(1.0+this.eccen);
};

// ߓ_Ԃ ߓ_ = Oa~( 1 - S)
Planet.prototype.getMinRadius=function(){
  return this.sma*(1.0-this.eccen);
};

// fWʒuvZ
Planet.prototype.calculateCoordinates=function(){
  var m=this.meanl-this.lofp+this.pinv*(julianDay-epoch);  // ϋߓ_p
  var eeh=0.5*eccentricAnomaly(m,this.eccen);
  var v=Math.PI;
  if(Math.cos(eeh)!==0.0){
    var tanv=Math.sqrt((1.0+this.eccen)/(1.0-this.eccen));
    v=2.0*Math.atan(tanv*Math.tan(eeh));
  }
  v+=this.lofp;
  var lens=this.sma*(1.0-this.eccen*Math.cos(2.0*eeh));
  var ss=Math.sin(v-this.lofan);
  var cinc=1.0-Math.cos(this.inc);
  this.p.set(lens*(Math.cos(v)+ss*Math.sin(this.lofan)*cinc),
      	     lens*(Math.sin(v)-ss*Math.cos(this.lofan)*cinc),
      	     lens*ss*Math.sin(this.inc));
};

// fƂ̋Ԃ
// pl - 𑪂Ώۂ̘f
Planet.prototype.distance=function(pl){
  return this.p.distance(pl.p);
};

// fNbN𔻒肷
// x,y - }EXʒu
Planet.prototype.click=function(x,y){
  if((this.pltype==SUN) || (this.pltype==viewMode)){
    var dx=this.vp.x-x;
    var dy=this.vp.y-y;
    return (dx*dx+dy*dy<=this.radius*this.radius);
  }
  else{
    return false;
  }
};

// f\ʒuݒ肷
Planet.prototype.setViewPosition=function(){
  var tp=this.p.clone();
  sa.rotatePoint(tp);
  this.vp.set(parseInt(rcoef*tp.x+cx),parseInt(rcoef*tp.y+cy),rcoef*tp.z);
};

// f`悷
Planet.prototype.draw=function(){
  if((this.pltype==SUN) || (this.pltype==viewMode)){
    drawOrbit(this);
    context.fillStyle=this.color;
    context.beginPath();
    context.arc(this.vp.x,this.vp.y,this.radius,0,2*Math.PI,false);
    context.closePath();
    context.fill();
  }
};

var TOLERANCE=1.0E-8;	// Pv[̋e덷
// Newton @gpėSߓ_p߂
// m - ϋߓ_p
// eccen - S
function eccentricAnomaly(m,eccen){
  var ei=m+eccen*Math.sin(m);
  var mi=ei-eccen*Math.sin(ei);
  var dm=Math.abs(m-mi);
  while(dm>TOLERANCE){
    ei=ei+(m-mi)/(1.0-eccen*Math.cos(ei));
    mi=ei-eccen*Math.sin(ei);
    dm=Math.abs(m-mi);
  }
  return ei;
}

var ORBIT_VIEW_COUNT=360;	// O_̐
// O`悷
// pl - ΏۂƂȂf
function drawOrbit(pl){
  var ccpa=Math.cos(pl.lofp-pl.lofan);
  var sspa=Math.sin(pl.lofp-pl.lofan);
  var cinc=1.0-Math.cos(pl.inc);
  var sinc=Math.sin(pl.inc);
  var ccan=Math.cos(pl.lofan)*cinc;
  var ssan=Math.sin(pl.lofan)*cinc;
  var ccp=Math.cos(pl.lofp);
  var ssp=Math.sin(pl.lofp);
  var m11=ccp+sspa*ssan;
  var m12=-ssp+ccpa*ssan;
  var m21=ssp-sspa*ccan;
  var m22=ccp-ccpa*ccan;
  var m31=sspa*sinc;
  var m32=ccpa*sinc;
  var smaY=pl.sma*Math.sqrt(1.0-pl.eccen*pl.eccen);
  var vp=new Point3D(0.0,0.0,0.0);
  var cc=1.0;
  var ss=0.0;
  var dtheta=2.0*Math.PI/ORBIT_VIEW_COUNT;
  var dc=Math.cos(dtheta);
  var ds=Math.sin(dtheta);
  context.beginPath();
  for(var i=0;i<ORBIT_VIEW_COUNT;i++){
    var x0=pl.sma*(cc-pl.eccen);
    var y0=smaY*ss;
    var x=m11*x0+m12*y0;
    var y=m21*x0+m22*y0;
    var z=m31*x0+m32*y0;
    vp.set(x,y,z);
    sa.rotatePoint(vp);
    if(i===0) context.moveTo(rcoef*vp.x+cx,rcoef*vp.y+cy);
    else      context.lineTo(rcoef*vp.x+cx,rcoef*vp.y+cy);
    var cctemp=cc*dc-ss*ds;
    var sstemp=ss*dc+cc*ds;
    cc=cctemp;
    ss=sstemp;
  }
  context.closePath();
  context.stroke();
}

//--------------------------------------------------------------------//
// Wpx
var SphericalAngle=function(){
  this.theta=0.0;
  this.phy=0.0;
  this.stheta=0.0;
  this.ctheta=1.0;
  this.sphy=0.0;
  this.cphy=1.0;
};

// pxݒ肷
// theta,phy - ,
SphericalAngle.prototype.set=function(theta,phy){
  while(theta<-Math.PI) theta+=2.0*Math.PI;
  while(theta>Math.PI) theta-=2.0*Math.PI;
  this.theta=theta;
  this.phy=Math.min(Math.max(phy,-0.5*Math.PI),0.5*Math.PI);
  this.stheta=Math.sin(this.theta);
  this.ctheta=Math.cos(this.theta);
  this.sphy=Math.sin(this.phy);
  this.cphy=Math.cos(this.phy);
};

// px]
SphericalAngle.prototype.rotate=function(dtheta,dphy){
  this.set(this.theta+dtheta,this.phy+dphy);
};

// _]
// p ]_
SphericalAngle.prototype.rotatePoint=function(p){
  var temp=this.ctheta*p.x+this.stheta*p.y;
  var x=-this.stheta*p.x+this.ctheta*p.y;
  var y=this.sphy*temp+this.cphy*p.z;
  var z=this.cphy*temp-this.sphy*p.z;
  p.set(x,y,z);
};

//--------------------------------------------------------------------//
// 3_
// x,y,z - x,y,zW
var Point3D=function(x,y,z){
  this.x=x;
  this.y=y;
  this.z=z;
};

// _̍Wݒ肷
// x,y,z - x,y,zW
Point3D.prototype.set=function(x,y,z){
  this.x=x;
  this.y=y;
  this.z=z;
};

// _Ƃ̋Ԃ
// p - 𑪂Ώۂ̓_
Point3D.prototype.distance=function(p){
  var dx=this.x-p.x;
  var dy=this.y-p.y;
  var dz=this.z-p.z;
  return Math.sqrt(dx*dx+dy*dy+dz*dz);
};

// _̃Rs[Ԃ
Point3D.prototype.clone=function(){
  return new this.constructor(this.x,this.y,this.z);
};

//--------------------------------------------------------------------//
// ڐ
var Scale=function(){
  this.length=0;
  this.label='';
};

// ڐݒ肷
// radius - `͈͔a
Scale.prototype.set=function(radius){
  var scp=Math.floor(Math.log(radius)/Math.log(10.0));
  var sc=Math.pow(10,scp);
  this.length=rcoef*sc;
  if(sc>=1.0) this.label=parseInt(sc)+'AU';
  else        this.label=sc+'AU';
};

// ڐ`悷
Scale.prototype.draw=function(){
  var yc=canvas.height-FONT_SIZE/2;
  var x2=SCALE_SIZE+this.length;
  context.beginPath();
  context.moveTo(SCALE_SIZE,yc-SCALE_SIZE);
  context.lineTo(SCALE_SIZE,yc+SCALE_SIZE);
  context.moveTo(x2,yc-SCALE_SIZE);
  context.lineTo(x2,yc+SCALE_SIZE);
  context.closePath();
  context.stroke();
  context.fillRect(SCALE_SIZE,yc-1,this.length,2);
  context.fillText(this.label,x2+SCALE_SIZE,canvas.height-2);
};
